



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>自动装配Bean</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">自动装配Bean</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 18:14:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Spring提供了几种技巧，可以减少XML的配置数量：</p>
<ul><li>自动装配（autowiring）：可以减少<code>&lt;property&gt;（setter注入）</code>和<code>&lt;constructor-arg&gt;（构造器注入）</code>元素，让Spring自动识别如何装配Bean的依赖关系；</li>
<li>自动检测（autodiscovery）：Spring能够自动识别哪些类需要被装配成Spring Bean，从而减少对<code>&lt;bean&gt;</code>的使用</li></ul>
<h4>4种自动装配</h4>
<ol><li>byName：&mdash;&mdash;根据Property的Name自动装配，如果一个bean的name，和另一个bean中的Property的name相同，则自动装配这个bean到Property中。</li>
<li>byType：&mdash;&mdash;根据Property的数据类型（Type）自动装配，如果一个bean的数据类型，兼容另一个bean中Property的数据类型，则自动装配。</li>
<li>constructor：&mdash;&mdash;根据构造函数参数的数据类型，进行byType模式的自动装配。</li>
<li>autodetect：&nbsp;&mdash;&mdash;先尝试使用constructor，失败后再使用byType。</li></ol>
<p>1.1、byName：</p>
<p>(1)Car.java</p>
<div>
<pre class="prettyprint linenums">public class Car {<br />
    public void start(){<br />
        System.out.println("starting car...");<br />
    }<br />
}</pre>
</div>
<p>(2)User.java&mdash;&mdash;此处是setter注入</p>
<div>
<pre class="prettyprint linenums">public class User {<br />
    private Car car;  

    public void setCar(Car car) {<br />
        this.car = car;<br />
    }  

    public void startCar(){<br />
        car.start();<br />
    }<br />
}  </pre>
</div>
<p>(3)xml配置文件：</p>
<p>原来是xml显式装配</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
       xsi:schemaLocation="http://www.springframework.org/schema/beans<br />
           http://www.springframework.org/schema/beans/spring-beans.xsd"&gt;  

       &lt;bean id="car" class="com.zzj.bean.Car"&gt;&lt;/bean&gt;<br />
       &lt;bean id="user" class="com.zzj.bean.User" &gt;<br />
            &lt;property name="car" ref="car" /&gt;<br />
       &lt;/bean&gt;<br />
&lt;/beans&gt; </pre>
</div>
<p>xml中自动装配后：</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
       xsi:schemaLocation="http://www.springframework.org/schema/beans<br />
           http://www.springframework.org/schema/beans/spring-beans.xsd"&gt;  

       &lt;bean id="car" class="com.zzj.bean.Car"&gt;&lt;/bean&gt;<br />
       &lt;bean id="user" class="com.zzj.bean.User" autowire="byName"&gt;&lt;/bean&gt;<br />
&lt;/beans&gt; </pre>
</div>
<p>(4)测试</p>
<div>
<pre class="prettyprint linenums">public static void main(String[] args) {<br />
        ApplicationContext context = new ClassPathXmlApplicationContext("applicationContext.xml");<br />
        User user = (User) context.getBean("user");<br />
        user.startCar();<br />
    } </pre>
</div>
<p>1.2、@Autowired注解实现自动装配（byType）</p>
<p>修改User.java文件和XML配置文件就行了。</p>
<p>(1)User.java</p>
<div>
<pre class="prettyprint linenums">import org.springframework.beans.factory.annotation.Autowired;  

public class User {<br />
    @Autowired<br />
    private Car car;  

    public void startCar(){<br />
        car.start();<br />
    }<br />
}</pre>
</div>
<p>注：此时setter方法可以省掉</p>
<p>(2)XML配置文件</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
       xmlns:context="http://www.springframework.org/schema/context"<br />
       xsi:schemaLocation="http://www.springframework.org/schema/beans<br />
           http://www.springframework.org/schema/beans/spring-beans.xsd<br />
           http://www.springframework.org/schema/context<br />
         http://www.springframework.org/schema/context/spring-context.xsd"&gt;  

       &lt;bean id="car" class="com.zzj.bean.Car"&gt;&lt;/bean&gt;<br />
       &lt;bean id="user" class="com.zzj.bean.User"&gt;&lt;/bean&gt;<br />
       &lt;context:annotation-config/&gt;  //开启自动注解<br />
&lt;/beans&gt;</pre>
</div>
<p>注：@Autowired（byType）是spring自带的注解，也可以使用Java原生的注解：@Resource（byName）。推荐使用@Resource，更具移植性</p>
<p>由于@Autowired是byType类型，可能会匹配多个Bean，那么哪个才是需要的呢</p>
<p>这时配合限定器@Qualifier("具体Bean的名字")就可以指定匹配的Bean了</p>
<p>@Autowired和@Resource区别：</p>
<p>http://bbs.csdn.net/topics/390175654</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g4955z9z.html">DBImport V3&period;7版本发布及软件稳定性（自动退出问题）解决过程分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kpvx69.html">linux I&sol;O复用</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwy7gz8.html">MySQL 5&period;6 双机热备</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zn3kd8.html">Linux 环境变量配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xox6r9.html">SQL null值 查询null</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xjw0w9.html">安装JDK后环境变量的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm3rz49.html">ubuntu挂载磁盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd543y8.html">ssh-keygen</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xdvv9.html">cocos2d-x之CCMotionStreak类&amp;mdash&semi;&amp;mdash&semi;2013-08-25 16</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jdjlv8.html">JavaScript算法描述（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zzgvj9.html">async And await异步编程活用基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zen5k9.html">NGINX----源码阅读---sources配置脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zdl219.html">React Native之APK文件签名及打包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwkxx9.html">grunt之clean、copy</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy10p6dq.html">内网神器-Bettercap</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdvwpd9.html">如何配置 Health Check？- 每天5分钟玩转 Docker 容器技术（107）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k6lm09.html">OpenCV处理视频序列的类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpyrgzq.html">python：前端（HTML）&plus;后端（Django）&plus;数据库（MySQL）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvjdkj8.html">百度学术导入endnote出现choose an import filter解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o722g8.html">SSM&plus;shiro及相关插件的整合maven所有依赖，详细注释版，自用，持续更新</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m96nnonq.html">android 文字图片合成</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q21l0x8.html">【转】PowerShell入门（二）：PowerShell是Cmd命令行的加强版吗？</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1x62z8.html">自定义view imageviw</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy37wd8.html">CoordinatorLayout 自定义Behavior并不难，由简到难手把手带你飞</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql0rneq.html">Linux之curl命令详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvwy0z9.html">es5&period;0 head插件安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy3k1d8.html">Python&mdash;进程、线程、协程</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kzx6r8.html">安装和使用sass</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rlv2d9.html">MySql&lowbar;十六进制值</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy3e4d8.html">使用VB6制作RTD函数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
